/***************************************************************************
 *            funcoes_geral.c
 *
 *  Sat Feb 19 12:22:36 2005
 *  Copyright  2005  Welington Rodrigues Braga
 *  welrbraga@gtk-br.cjb.net
 ****************************************************************************/

#include <gnome.h>
#include <glade/glade.h>

#include "include/funcoes_geral.h"

gdouble
get_valor (gchar * meu_widget)
{				/* Lê o valor do widget */
	/* Pega o widget especificado */
	GtkWidget *wid = glade_xml_get_widget (xml, meu_widget);

	/* Pega o tipo do widget */
	gchar *wid_tipo = g_strdup (G_OBJECT_TYPE_NAME (wid));

	/*      Retorno do valor nos objetos  */
	const gchar *retorno = NULL;

	/* Verifica se o widget é uma caixa de entrada */
	if (!strncmp (wid_tipo, "GtkEntry", 8))
	{
		retorno = gtk_entry_get_text (GTK_ENTRY (wid));
	}
	else
		/* Verifica se o widget é um rótulo */
	if (!strncmp (wid_tipo, "GtkLabel", 8))
	{
		retorno = gtk_label_get_text (GTK_LABEL (wid));
	}

	/* Tranforma a string de retorno em um número */
	gdouble saida = g_ascii_strtod (retorno, NULL);

	g_free (wid_tipo);
	return saida;
}

void
set_valor (gchar * meu_widget, gdouble valor)
{				/* Define o valor do widget */
	/* Pega o widget especificado */
	GtkWidget *wid = glade_xml_get_widget (xml, meu_widget);

	/* Pega o tipo do widget */
	gchar *wid_tipo = g_strdup (G_OBJECT_TYPE_NAME (wid));

	/* Converte o número de entrada em um string de 12 posições */
	gchar buffer[12];
	const gchar *valor_txt = g_ascii_dtostr (buffer, 12, valor);

	/* Verifica se o widget é uma caixa de entrada */
	if (!strncmp (wid_tipo, "GtkEntry", 8))
	{
		gtk_entry_set_text (GTK_ENTRY (wid), valor_txt);
	}
	else
		/* Verifica se o widget é um rótulo */
	if (!strncmp (wid_tipo, "GtkLabel", 8))
	{
		gtk_label_set_text (GTK_LABEL (wid), valor_txt);
	}
	g_free (wid_tipo);
}
